
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ASP .NET 中的身份验证：.NET 安全性指导 / iVAN</title>

    <meta name="description" content="ASP .NET 中的身份验证：.NET 安全性指导 安全|安全性 摘要本文讨论了设计服务器应用程序时考虑安全性的重要性.Internet Information Services 和 ASP .NET 均提供了安全模型,以便您对用户进行适当的身份验证,并在应用程序中获得正确的安全环境. -------------------------------------------------------------------------------- 目录简介安全性考虑IIS 和 ASP .NET 之间的关系身份验证方法Web 服务的安全性代码访问安全">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ASP .NET 中的身份验证：.NET 安全性指导</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>安全|安全性</p>
<p>摘要<br />本文讨论了设计服务器应用程序时考虑安全性的重要性。Internet Information Services 和 ASP .NET 均提供了安全模型，以便您对用户进行适当的身份验证，并在应用程序中获得正确的安全环境。</p>
<p>--------------------------------------------------------------------------------</p>
<p>目录<br />简介<br />安全性考虑<br />IIS 和 ASP .NET 之间的关系<br />身份验证方法<br />Web 服务的安全性<br />代码访问安全性<br />通道安全性<br />其他信息<br />附录 A</p>
<p>--------------------------------------------------------------------------------</p>
<p>简介<br />不论对应用程序设计者还是开发人员，安全性都是关注的主要问题。您需要保护存储敏感信息的应用程序，既要防止恶意攻击，又要防止竞争对手窃取信息或知识产权。在为您的应用程序设计安全模型时，您需要从业务角度了解安全要求，以及选定的安全模型在性能、可伸缩性和部署上所具有的含义。</p>
<p>--------------------------------------------------------------------------------</p>
<p>安全性考虑<br />如果您在设计服务器应用程序，那么您的设计规范应包含一个解决安全问题的部分。在应用程序的功能规范中，您应当考虑以下项目并尽可能给出解决方案： <br />安全目标。理解您要保护的对象并确保您可以说明它。<br />安全风险。理解您的应用程序的弱点。您还必须理解这些弱点对业务的潜在危害程度。<br />身份验证。这一过程接受用户凭据，并根据指定的颁发机构来验证凭据。用户的（或者潜在的应用程序或计算机的）标识被称为安全当事者。客户端必须提供凭据，以便服务器验证当事者的标识。确认标识后，应用程序就能授权当事者访问系统资源。本文档的下一节将讲述各种标准，它们有助于您选择恰当的身份验证机制。<br />权限。这一过程确定已证实的标识是否可以访问某一特定资源。<br />保护数据传输。在数据通过网络时对数据进行加密，可以确保数据在传输过程中不被查看和修改。您必须考虑传输过程中需要的数据加密级别。<br />模拟。这一机制允许服务器进程使用客户端的安全凭据来运行。当服务器模拟客户端时，服务器的所有操作均使用客户端的凭据进行。模拟不允许服务器代表客户端访问远程资源。该操作需要使用代理。<br />代理。和模拟一样，代理允许服务器进程使用客户端的安全凭据来运行。但是，代理的功能更加强大，它允许服务器进程以客户端方式来呼叫其他计算机。<br />操作系统安全性。它指建立适当的访问控制列表 (Access Control List, ACL) 和网络安全措施，以防止入侵者访问受保护的资源。您必须为适当的资源设置适当的 ACL，从而只允许相关的当事者进行访问。<br />保护物理访问。是指将您的服务器计算机放在一个安全的房间中。您不应忽视这个基本问题。<br />代码访问安全性。它允许根据代码的来源及代码标识的其他特征来确定代码的可信度。您应当了解如何创建自己的访问许可。</p>
<p>--------------------------------------------------------------------------------</p>
<p>IIS 和 ASP .NET 之间的关系<br />在设计应用程序时，您应理解 Internet Information Services (IIS) 身份验证和 Microsoft ASP .NET 安全结构之间的关系。这将允许您恰当地验证您的用户，并在应用程序中获得正确的安全环境。请注意，ASP .NET 应用程序的安全配置和 IIS 的安全配置是完全独立的，它们可以单独使用，也可以结合使用。 <br />IIS 在 IIS 元数据库中维护与安全性相关的配置设置，而 ASP .NET 在 XML 配置文件中维护安全（或其他）配置设置。这一般会在安全性方面简化应用程序的部署，但应用程序采用的安全模型则需要通过配置文件 (Web.config) 正确配置 IIS 元数据库和您的 ASP .NET 应用程序。 <br />图 1 说明了 IIS 和 ASP .NET 之间的关系。</p>
<p>图 1：IIS 和 ASP .NET 之间的安全性关系<br />ASP .NET 身份验证提供程序和 IIS 安全性<br />ASP .NET 通过使用身份验证提供程序来实现身份验证，身份验证提供程序是验证凭据和实现其他安全功能（例如生成 Cookie）的代码模块。ASP .NET 支持以下三种身份验证提供程序： <br />表单身份验证。使用该提供程序，可以使用客户端重定向将未通过身份验证的请求重定向到指定的 HTML 表单。然后，用户可以提供登录凭据，并将表单发送回服务器。如果应用程序验证了请求（使用应用程序特定的逻辑），ASP .NET 将发出一个 Cookie，其中包含凭据或用于重新申请客户标识的密钥。后续发出的请求在标头携带该 Cookie，这就意味着以后不再需要身份验证。 <br />Passport 身份验证。这是一个由 Microsoft 提供的集中身份验证服务，它为参与的站点提供单一的登录程序和成员服务。ASP .NET 与 Microsoft Passport 软件开发包 (SDK) 相结合，为 Passport 用户提供了类似表单身份验证的功能。<br />Windows 身份验证。该提供程序利用了 IIS 的身份验证功能。当 IIS 完成身份验证后，ASP .NET 使用已验证标识的标记来授权访问。 <br />要在 ASP .NET 应用程序中使用某种指定的身份验证提供程序，您必须在应用程序配置文件中创建如下项： <br />// web.config 文件<br />&lt;authentication mode = "[Windows/Cookie/Passport/None]"&gt;<br />&lt;/authentication&gt;<br />除身份验证外，ASP .NET 还提供了模拟机制以建立应用程序线程的安全标记。能否获得正确的标记取决于您是否恰当地配置了 IIS 身份验证、ASP .NET 身份验证提供程序和 ASP .NET 模拟设置。图 2 显示了 IIS 身份验证和 ASP .NET 提供程序之间最可能的组合。</p>
<p>图 2：ASP .NET 和 IIS 安全设置矩阵<br />使用 Windows 帐户进行身份验证<br />如果您计划使用 Microsoft Windows NT 域控制器或 Microsoft Windows 2000 Active Directory 帐户来进行用户身份验证，您应当结合使用 IIS 身份验证和 ASP .NET Windows 提供程序（见图 2）。使用该方法，您不必编写任何特定身份验证代码。当使用该方法验证时，ASP .NET 根据已验证用户在应用程序环境中构造并附加一个 Windows Principal 对象。这样，ASP .NET 线程就能够作为已验证用户运行，并可获得用户的组成员身份。 <br />在某些情况下，您可能希望忽略 IIS 身份验证，而实施自定义的解决方案。使用 ASP .NET 也可以实现这一目标。例如，您可以编写自定义 ISAPI 过滤器，根据 Active Directory 检查用户凭据，并手动创建 Windows Principal 对象。除这种方法外，还有其他一些方法可以使用，但是与直接使用 .NET 提供程序相比，它们都需要编写更多的代码。 <br />使用非 Windows 帐户进行身份验证<br />如果您计划在应用层进行用户身份验证，并且用户没有 Windows 帐户，则一般应将 IIS 配置为使用匿名验证。在这种配置下，请考虑以下 .NET 身份验证模块： <br />无：在根本不验证用户时或开发自定义验证代码时使用。<br />表单：在需要为用户提供登录页时使用。<br />Passport：在使用 Passport 服务时使用。<br />模拟和代理<br />在模拟情况下，ASP .NET 应用程序能够使用客户端标识以客户端的身份有选择地执行。模拟一般用于资源访问控制。您应仔细考虑是否需要模拟，因为它将消耗额外的服务器资源。代理是一种比模拟更强大的形式，它允许服务器进程以客户端的身份访问远程资源。 <br />如果启用模拟，ASP .NET 将从 IIS 收到模拟标记。与传统的 Active Server Pages (ASP) 相比，使用 ASP .NET 将使您在 Web 应用程序中更广泛地控制模拟。这种控制是通过在应用程序的 Web.config 文件中指定值来实现的。 <br />在指定所需的模拟设置时，有以下三个选项： <br />启用模拟。在这种情况下，ASP .NET 将模拟由 IIS 传递给它的标记，该标记可能是已验证的用户，也可能是匿名 Internet 用户帐户。 <br />&lt;identity impersonate="true"/&gt; <br />启用模拟，使用指定的特定模拟标识。在这种情况下，ASP .NET 将模拟使用配置的标识生成的标记。此时不使用客户端标记（即使有）。 <br />&lt;identity impersonate="true" username="domain\user" password="pwd"/&gt; <br />禁用模拟。此选项是默认设置，以便与 ASP 向后兼容。在这种情况下，ASP .NET 线程将使用应用程序辅助进程的进程标记（默认情况下为 IIS 系统帐户）来运行，而不考虑采用的是 IIS 和 ASP .NET 身份验证的何种组合。 <br />&lt;identity impersonate="false"/&gt; <br />如果应用程序驻留在 UNC 共享中，ASP .NET 将一直模拟 IIS UNC 标记以访问该共享，除非使用了配置帐户。如果提供了显式配置的帐户，ASP .NET 将优先使用该帐户。 <br />表 1 显示了根据三种不同的 Web.config 配置来执行请求的线程标记。请注意，IUSR_SERVER 帐户表示已配置用于匿名访问当前 URL 的帐户（即，该帐户不必是 IUSR_ 帐户）。进程帐户是应用程序辅助进程运行时使用的帐户：默认情况下，该帐户为系统帐户，除非进行专门配置。 <br />表 1：ASP 和 IIS 配置的 ASP 线程标记</p>
<p>应用程序标识<br />建议您使用专门配置的帐户来运行 ASP .NET 应用程序辅助进程 (aspnet_wp.exe)，该帐户的权限比默认系统帐户低。主要原因有两个。第一，如果出现安全问题，入侵者没有管理权限。第二，它允许应用程序服务提供者 (ASP) 使用较低权限的帐户运行应用程序，因此寄宿的应用程序不会破坏服务器计算机的完整性或执行需要管理员权限的操作。 <br />要使用指定帐户运行 ASP 辅助进程，需要在 \WINNT\Microsoft.NET\Framework\Version\Config 文件夹下的根配置文件 (machine.config) 中添加一个 &lt;processModel&gt; 元素，如下所示： <br />&lt;system.web&gt;<br />  &lt;processModel enable="true" username="domain\user" password="pwd"/&gt;<br />&lt;/system.web&gt;<br />除指定特定的用户帐户外，您还可以将 username 属性设置为两个专门识别的值“SYSTEM”和“MACHINE”之一。无论设为哪个值，密码属性必须设为“AutoGenerate”，因为不需要指定凭据。“SYSTEM”设置（默认）使用系统帐户运行辅助进程，而“MACHINE”使用名称中带前缀 ASPNET 的特殊帐户运行辅助进程。该帐户与 IWAM_MACHINENAME 帐户相同，IIS 寄放标准 ASP 应用程序时使用 IWAM_MACHINENAME 帐户来运行 dllhost.exe 的实例。ASPNET 帐户在 .NET 的安装过程中创建。 <br />如果您使用自定义帐户，该帐户必须具有对以下目录的必要访问权限。 <br />对 %installroot%\ASP .NET 临时文件目录具有读/写访问权限。该根目录下的子目录用于动态编译输出。<br />对 %temp% 目录具有读/写访问权限。在动态编译过程中，编译器将使用该目录。 <br />对应用程序目录具有读访问权限。 <br />对 %installroot% 层次结构具有读访问权限，以允许访问系统程序集。<br />请注意，相关的 ACE 是在安装 ASPNET 帐户的过程中定义的。 <br />如果您使用专门配置的进程帐户，您应了解它对使用模拟的限制。虽然您可以继续模拟客户端标识，但您不能使用模拟的扩展形式（其指定的模拟帐户已在应用程序的 Web.config 文件中定义）。这是因为该选项要求辅助进程具有 SE_TCB_NAME (“作为操作系统的一部分运行”) 权限，而权限较低的进程标识一般不具有此权限。针对每个请求的模拟仍然有效，因为 IIS 创建了登录会话，并将模拟标记直接传递给辅助进程。请注意，此限制仅适用于 Windows 2000 和 Windows NT 4。Microsoft Windows XP 包含有增强功能，允许在不具有此权限的情况下生成特定的登录会话。 <br />详细信息，请阅读《.NET 框架开发人员指南》的以下章节： <br />ASP .NET 安全性的工作原理 <br />ASP .NET 身份验证 <br />ASP .NET 配置概念 <br />结合使用 IIS 身份验证与 ASP .NET 模拟 <br />有关 IIS 5.0 中身份验证的详细信息，请参阅文章 Internet Information Services 5.0 身份验证方法（英文）。</p>
<p>--------------------------------------------------------------------------------</p>
<p>身份验证方法<br />在 .NET Web 应用程序中可以采用各种身份验证选项。例如，您可以选择使用某种受支持的 IIS 身份验证机制，或在应用程序代码中执行身份验证。选择身份验证方法时，应考虑以下部分或所有因素： <br />服务器和客户端操作系统 <br />客户端浏览器类型 <br />用户数量、位置、用户名以及密码数据库类型 <br />部署考虑，如应用程序是基于 Internet 还是 Intranet，及其是否位于防火墙之后。 <br />应用程序类型，如，是交互式网站还是非交互式 Web 服务 <br />要保护的数据的敏感度 <br />性能和可伸缩性因素 <br />身份验证要求。例如，您希望所有用户均可使用应用程序；或希望限制某些区域仅供注册用户使用，而另一些区域“仅限管理员使用”。<br />确定身份验证方法<br />使用附录A中的流程图，有助于您根据具体应用程序的要求确定最适合的身份验证方法。要使用该流程图，请先回答有关用户群和部署模型性质的问题。图的结尾处为适当的备选身份验证方法。 <br />检查完流程图后，您应研究以下小节。这些小节提供了关于各种身份验证方法的更详细信息，并提供进一步的指导以帮助您优化决策程序。在本节将要结束之际，您应该能够选出一个备选身份验证方法。 <br />流程图决策点解释<br />用户是否必须登录？是否需要用户名和密码以访问站点或服务？ <br />是否需要个性化？站点是否可以不需要用户登录而提供个性化内容？ <br />用户帐户？用户帐户是存储于 Windows NT 域帐户、Active Directory，还是其他数据存储区，例如关系型数据库、其他 LDAP（轻便目录访问协议）目录服务或 XML 文件？<br />需要单一登录还是无缝登录？您是否希望用户从登录页登录，或需要自动进行身份验证？例如，在自动化的企业对企业 (B2B) 交易中可能需要自动身份验证。<br />您是否需要安全登录？您的系统是否需要使黑客极难通过网络来盗用用户名和密码？这个决策一般是根据站点上可用数据的敏感度来做出的。 <br />应用程序将在 Internet 上运行吗？应用程序是否位于防火墙之后（用户未经过域身份验证），或应用程序将基于 Intranet（最终用户可能已经过域身份验证）？ <br />您是否需要代理安全环境？您是否需要业务组件与呼叫方标识共同运行？如果是这样，则需要模拟。而且，如果您需要访问系统资源（例如消息队列、数据库或远程计算机中的文件系统），则需要代理级别的模拟。<br />服务器和客户端是否仅运行 Windows 2000？运行环境中的计算机是同样运行 Windows 2000，还是会有客户端运行着其他操作系统（如 Windows 9x 和 Windows NT 4.0）？<br />匿名身份验证<br />使用匿名身份验证，服务器不请求客户端向其发送用户凭据。如果您的站点或服务可供公开使用，而您不必知道呼叫方的标识，那么这就是一个好的选择。同时，也不会由于与支持的身份验证机制不兼容而造成浏览器限制。所有用户均可访问配置为匿名身份验证的站点。值得注意的是，尽管您可能已配置了 IIS 以进行匿名身份验证，但身份验证可能是在 ASP .NET 层进行，而这并不是真正的匿名身份验证。本节假设 IIS 和应用程序均不要求登录。 <br />典型应用方案<br />以下情况下，您应考虑使用匿名身份验证： <br />无论是对于登录还是业务逻辑组件，您都不需要知道呼叫方的名字和/或密码。 <br />您所保护的信息被认为是“公有的”。 <br />以下情况下，您不应考虑使用匿名身份验证： <br />您要求使用登录名和密码以限制用户群。 <br />其他考虑<br />选择匿名身份验证时，您还应考虑以下问题。 <br />站点中仅包含个性化内容<br />如果您设计的站点仅包含个性化内容，则匿名身份验证可能是一个好选择。例如，新闻站点可以根据用户的邮政编码来提供当地信息，而不需要用户明确登录。个性化功能可以通过使用独立于身份验证的 Cookie 来执行。有关 Cookie 的详细信息，请参阅本文档后面的 Cookie 一节。 <br />模拟<br />当使用匿名身份验证时，应用程序线程将运行为： <br />内部匿名 Internet 帐户 IUSR_MACHINENAME。 <br />在 IIS 中为匿名用户配置的帐户。 <br />IIS 系统帐户。<br />如果您的应用程序使用其他资源，例如 COM+ 组件、数据库、消息队列或 UNC 文件共享，您需要为匿名用户启用相应权限。如果是这样，请考虑以下选项： <br />设置域控制器以包含所有 Web 和应用程序服务器。配置匿名用户以作为域用户运行，并具有访问相应资源的权限。此方法中的帐户管理是集中进行的，因此更易于管理。 <br />如果您不在域中运行，则可以在每个 Web 和应用程序服务器中创建一个具有相同名字和密码的用户。由于重复帐户的管理比较复杂，所以并不推荐这种方法。 <br />性能<br />使用匿名网站而不使用 ASP .NET 模拟将带来最佳性能，但是应用程序配置的安全性最差。 <br />实现<br />要实现匿名身份验证，应为匿名身份验证配置 IIS 并配置适当的匿名用户帐户。使用 Web.config 文件配置 ASP .NET 以使用无身份验证。 <br />//web.config 文件<br />&lt;system.web&gt;<br />   &lt;authentication mode="None" /&gt;<br />&lt;/system.web&gt;<br />基本身份验证<br />当 IIS 配置为基本身份验证时，它将指示浏览器通过 HTTP 发送用户凭据。密码和用户名使用 Base64 编码方法进行编码。尽管密码已经编码，但由于其解密相对较容易，所以仍然是不安全的。浏览器将通过对话框提示用户，然后重新发出原始匿名请求和提供的凭据（包括用户名和密码）。弹出式登录对话框不一定适合您的用户界面设计要求。大多数 Internet 浏览器支持基本身份验证。 <br />典型应用方案<br />以下情况下，您应考虑使用基本身份验证： <br />您的用户具有 Windows NT 域或 Active Directory 帐户。 <br />您需要支持多个浏览器类型，包括 Netscape Navigator 和所有版本的 Internet Explorer（包括 Pocket PC 和 Windows CE 平台）。 <br />您需要支持通过 Internet 进行身份验证。 <br />您需要在应用程序代码中访问明文密码。 <br />您需要支持代理。 <br />以下情况下，您不应考虑使用基本身份验证： <br />需要安全登录且不使用安全通道，例如由安全套接字层 (SSL) 提供的通道。 <br />您的用户存储在自定义数据库中，并且没有 Windows 帐户。 <br />您需要一个自定义表单作为登录页提供给用户。 <br />其他考虑<br />选择基本身份验证时，您还应考虑以下问题： <br />使用基本身份验证代理<br />您可以使用基本身份验证从一个计算机代理另一个（但不要超过一个）。代理会发生是因为 IIS 服务器将通过调用 Win32 API LogonUser 实现本地登录。由于 IIS 拥有用户的明文密码，它可以响应远程计算机的挑战，允许 Web 服务器代表客户端操作。如果您需要代理其他计算机的安全环境（超过单个跃点)，则必须本地登录到呼叫链中的其他计算机。通过使用基本身份验证能够实现这一点，因为您可以访问用户的名字和明文密码，而名字和明文密码可以传递给其他应用程序（例如基于 ISAPI 或 CGI 的应用程序）。 <br />保护基本身份验证<br />值得注意的是，密码的破译相对容易，因此您应将基本身份验证的使用限制在非安全或至多是半安全的应用程序中。 <br />您可以通过与 SSL 结合来保护基本身份验证。这将防止密码被破译。目前的许多 Internet 应用程序都结合使用了基本身份验证和 SSL。 <br />实现<br />要实现基本身份验证，应在 IIS 内对其进行配置，并确保您的用户在 Web 服务器上具有“本地登录”权限。如果您的 ASP .NET 应用程序需要作为经过基本身份验证的用户来运行，请使用以下 Web.config 文件配置。 <br />// web.config 文件<br />&lt;system.web&gt;<br />   &lt;authentication mode="Windows" /&gt;<br />&lt;/system.web&gt;</p>
<p>简要身份验证<br />简要身份验证是 Windows 2000 和 IIS 5.0 的新功能。这种身份验证形式能够加密用户的密码信息并提供一种机制以便防止某些常见的服务器攻击（如重放攻击）。简要身份验证不像基本身份验证那样使用明文通过网络发送凭据。相反，它使用一种由 RSA 开发的散列机制，称为 MD5。（有关详细信息，请参阅位于 http://www.ietf.org/rfc/rfc1321.txt ;的“MD5 消息简要算法” 。）尽管它对于 Internet 来说是一个可行的身份验证选择，但客户端和服务器的要求限制了它的广泛使用。IIS 与基本身份验证不同，而与 NTLM 和 Kerberos 类似。它不在本地登录 Web 服务器，因此不能执行代理。 <br />典型应用方案<br />以下情况下，您应考虑使用简要身份验证： <br />您的 Web 服务器运行 Windows 2000，并且您的用户在 Active Directory 中存储有 Windows 帐户。 <br />您所有的客户端均使用 .NET 平台或 Internet Explorer 5.x。 <br />您需要比基本身份验证更强大的密码加密方法。 <br />您需要支持通过 Internet 进行身份验证。 <br />以下情况下，您不应考虑使用简要身份验证： <br />您的某些客户端使用非 .NET 或 Internet Explorer 5.0（或更高版本）的平台。 <br />您的用户在 Active Directory 中没有存储 Windows 帐户。 <br />您需要代理。<br />其他考虑<br />选择简要身份验证时，您还应考虑以下问题。 <br />保护简要身份验证<br />简要身份验证的目的是提供比基本身份验证更安全的登录方法。然而，它没有与 SSL、NTLM、Kerberos 或证书身份验证相结合的基本身份验证安全。 <br />通过 SSL 使用简要身份验证是一个安全的解决方案，但是其部署要求目前限制了它的广泛使用。 <br />简要身份验证的特定平台要求<br />简要身份验证要求客户端运行 .NET 或 Internet Explorer 5.x。用户帐户必须存储在 Active Directory 中，且 Active Directory 必须针对简要身份验证进行配置。 <br />实现<br />您必须为简要身份验证配置 IIS。有关详情，请参阅 Microsoft 知识库文章 Q222028，设置简要身份验证以使用 Internet Information Services 5.0（英文）。 <br />如果您的 ASP .NET 应用程序需要作为已进行 IIS 简要身份验证的验证用户来运行，请使用以下 Web.config 配置： <br />// web.config 文件<br />&lt;system.web&gt;<br />&lt;authentication mode="Windows" /&gt;<br />&lt;/system.web&gt;</p>
<p>要在 Windows 2000 中使用简要身份验证，服务器必须能访问设置为进行简要身份验证的 Active Directory 服务器。 <br />有关简要身份验证的详细信息，请参阅 RFC 2069 规范 http://www.ietf.org/rfc/rfc2069.txt)。 <br />集成 Windows 身份验证<br />集成 Windows 身份验证（使用 NTLM 挑战/响应或 Kerberos）涉及对具有 Windows NT 域或 Active Directory 帐户的用户进行身份验证。与基本身份验证和简要身份验证不同，在该方法中加密密码不通过网络发送，因而非常安全。如果服务器中安装有 Active Directory 服务，且浏览器与 Kerberos V5 身份验证协议兼容，则将使用 Kerberos V5 协议和挑战/响应协议，否则将仅使用挑战/响应协议。该方法最适合 Intranet 环境。在这种环境中，用户和 Web 服务器计算机在同一个域中，管理员可以保证每台计算机均运行 Microsoft Internet Explorer 版本 3.01 或更高版本。 <br />典型应用方案<br />以下情况下，您应考虑使用集成 Windows 身份验证： <br />您的用户具有 Windows NT 域或 Active Directory 帐户。 <br />您的应用程序运行于 Intranet 上（在防火墙后）。 <br />所有客户端均运行 Internet Explorer 版本 3.01 或更高版本。 <br />您需要执行代理（这需要 Kerberos）。 <br />您需要为域用户采用无缝登录程序（例如，没有弹出式登录对话框）。 <br />以下情况下，您不应考虑使用集成 Windows 身份验证： <br />您的用户帐户是存储在外部数据库中，而不是存储在 Windows NT 域数据库或 Active Directory 中。 <br />您需要支持通过 Internet 进行身份验证。 <br />您的客户端使用 Netscape Navigator 或其他非 Microsoft 浏览器。 <br />您需要获得客户的明文密码。 <br />其他考虑<br />选择集成 Windows 身份验证时，还应考虑以下问题。 <br />NTLM 和 Kerberos 的安全级别<br />这两种协议均高度安全。对于 NTLM 和 Kerberos 协议，密码不通过网络传输。NTLM 使用一种挑战/响应机制。Kerberos 甚至更加安全，因为它支持互相验证（即，客户端可以验证其与之通讯的服务器）。 <br />代理问题<br />NTLM 协议不支持代理。当客户端的凭据传送到 IIS 服务器之后，它们不能被传送到后端服务器进行身份验证。但是，Kerberos 支持代理，允许多个下游计算机的其他进程代理客户端凭据。例如，您可以使用 Kerberos 将 Web 用户的凭据提供给 COM+ 中间层，并通过该层到达 Microsoft SQL Server 数据库（配置为 Windows 集成安全性）。Active Directory 的默认配置中未启用 Kerberos 身份验证。在决定将其作为代理解决方案之前，您必须确保您的环境支持 Kerberos。 <br />Internet 的使用<br />NTLM 和 Kerberos 协议在 Internet 中均不常用。要在 Internet 中使用 Kerberos，关键问题是安全授权需要集中并对所有用户可用。只有基础设施到位才能实现这一点。部署 Internet 的另一个问题是非 Microsoft 浏览器不支持这些协议。对于特定的客户群，这可能会是一个限制因素。 <br />性能和可伸缩性<br />Kerberos 比 NTLM 快。但是，这两种协议均比基本身份验证或某些自定义身份验证方法慢。如果您希望大量用户同时登录，就需要仔细设计 Active Directory 的配置。如果您拥有数百万的潜在用户，则您可以考虑使用高性能数据库（如 SQL Server）来存储用户的名字和密码。如果您在多层应用程序中代理安全环境，就很可能会遇到可伸缩性问题。特别是，不能使用数据库连接池等中间层解决方案。 <br />实现<br />要实现 Kerberos 或 NTLM，您需要配置 IIS 以使用集成 Windows 身份验证。如果您需要支持运行非 Internet Explorer 的客户端，则可以启用基本身份验证以结合 NTLM 或 Kerberos。 <br />配置 Kerberos 时，您需要考虑这些特定细节： <br />客户端和服务器必须都在同一 Windows 2000 域中运行 Windows 2000。 <br />必须启用客户端的用户帐户以使用代理。 <br />必须启用服务器的帐户以使用代理。<br />如果您的 ASP .NET 应用程序需要作为已由 IIS 使用集成 Windows 身份验证进行过验证的用户来运行，请使用以下 Web.config 配置： <br />// web.config 文件<br />&lt;system.web&gt;<br />   &lt;authentication mode="Windows" /&gt;<br />&lt;/system.web&gt;<br />有关使用 Kerberos 的详细信息，请参阅： <br />Windows 2000 中的 Kerberos 组件（英文） <br />Kerberos 说明（英文） <br />证书身份验证<br />证书是安装在计算机中的数字“密钥”。计算机试图访问服务器时，密钥将自动传送以对用户进行身份验证。客户端证书可被映射到域或 Active Directory 中的 Windows 帐户。如果您在 ASP .NET 中使用 Windows 身份验证提供程序，应用程序线程将作为证书所映射的用户运行。您也可在 ASP .NET 中实现自定义身份验证，例如，您可以使用证书内包含的电子邮件地址（或类似的唯一字段）。从客户端的观点来看，安全性是无缝的，因为客户端不需要使用登录页来登录。这就使得证书在自动化业务流程方面成为一个有吸引力的选择。 <br />典型应用方案<br />以下情况下，您应考虑使用证书身份验证： <br />您所保护的数据非常敏感，您需要非常安全的解决方案。 <br />您需要互相身份验证。 <br />您希望第三方能够管理服务器和证书拥有者之间的关系。 <br />您希望实现无缝的客户端交互，例如自动 B2B 交易。<br />以下情况下，您不应考虑使用证书身份验证： <br />发布和管理客户端证书的成本超过了增加安全性所获得的价值。 <br />其他考虑<br />选择证书身份验证时，您还应考虑以下问题。 <br />部署<br />您需要将客户端证书物理部署在客户端工作站中。有多种方法可以进行此部署，从 Web 部署到从 CD-ROM 安装证书。通常是部署的问题导致了证书模式的使用不如其他与 SSL 相结合的身份验证模式广泛。 <br />映射到 Windows 帐户<br />可以将证书映射到域或 Active Directory 帐户。如果需要对个别用户进行身份验证，可以使用一种称为“一对一映射”的技术，将证书映射到单独帐户。如果使用 Active Directory 映射，则对一对一映射没有限制。 <br />如果需要验证来自特定组或组织的所有用户，则可以使用多对一映射，例如，将所有包含同一公司名称的用户映射到一个帐户。 <br />例如，考虑以下 B2B 方案： <br />公司 A 允许其合作公司 B 查看其部分内部网站。 <br />公司 B 的计算机安装有证书。 <br />多对一映射的结果是，ASP .NET 应用程序将作为通用的“CompanyB” Windows 帐户运行。 <br />有关证书的深入信息，请参阅由 Michael Howard 所著的《设计 Microsoft Windows 2000 基于 Web 的安全应用程序》。 <br />实现<br />您必须配置 IIS 以进行证书身份验证。有关将公共密钥证书映射到 Windows 2000 用户帐户的详细信息，请参阅将证书映射到用户帐户的循序渐进指南（英文）。 <br />Passport 身份验证<br />Passport 身份验证是由 Microsoft 提供的集中身份验证服务。使用 Passport 时，在某些情况下您不必实现自己的身份验证代码、登录页和用户表。Passport 使用 Cookie 机制工作。如果客户端以前已经通过了 Passport 验证，则允许它们访问您的站点。否则，它们将被自动重定向到 Passport 站点以进行身份验证。 <br />如果您需要在多个域之间进行单一登录（这些域也支持 Passport），那么 Passport 是一个好选择。Passport 不仅提供身份验证服务，还提供包括配置文件管理和采购服务在内的其他服务。 <br />在 Windows 2000 平台上，Passport 没有直接集成到操作系统内部的任何身份验证和授权机制。.NET 框架确实会检查 Passport Cookie，但如果您维护自己的数据库，您必须实现自己的代码，以将 Passport 用户映射为自己的用户，同时还要实现自己的授权机制。 <br />典型应用方案<br />以下情况下，您应考虑使用 Passport 身份验证： <br />您的站点要与其他启用 Passport 的站点结合使用，同时您希望访问这些站点的用户能够进行单一登录。 <br />您不想维护用户名和密码数据库。<br />以下情况下，您不应考虑使用 Passport 身份验证： <br />您希望使用已经存储在自己的数据库或 Active Directory 中的用户名和密码。（尽管有可能使用额外的代码将 Passport ID 映射为用户帐户。） <br />您的客户端是通过编程来访问站点的其他计算机。 <br />其他考虑<br />选择 Passport 身份验证时，您还应考虑以下问题。 <br />启用 Passport<br />使用 Passport 身份验证要求站点注册 Passport 服务并在服务器中安装 Passport SDK。 <br />代理<br />在 Windows 2000 中，不可能从一个服务器将用户的 Passport 安全凭据代理到另一个。 <br />映射到用户帐户<br />Passport 用户 ID (PUID) 仅仅是一个标识。如果您的用户帐户是在 Active Directory 或任何自定义数据库中定义的，并且您需要将 PUID 映射为用户，则您需要实现自己的自定义代码。Windows 的未来版本可能会提供将 PUID 映射到 Windows 帐户的本机支持。 <br />保护 Passport<br />当 Passport 作为单机身份验证方法使用时，加密 Cookie 的本质使得 Passport 比较安全。然而，为了避免重放攻击并维持最高安全级别，Passport 需要与 SSL 结合使用。 <br />实现<br />要实现 Passport，您需要在服务器中安装 Passport SDK。您还需要向 Passport 注册以使用服务。您必须按如下方法配置 web.config 文件： <br />// web.config 文件<br />&lt;system.web&gt;<br />   &lt;authentication mode="Passport" /&gt;<br />&lt;/system.web&gt;<br />有关 Passport 服务的详细信息，请参阅： <br />Passport 身份验证提供程序（英文） <br />Passport 技术白皮书（英文） <br />Passport 开发人员信息（英文） <br />表单身份验证<br />表单身份验证是指接受用户凭据的自定义用户界面组件，例如，一个用户名和密码。现在使用的许多 Internet 应用程序具有这种供用户登录的表单。值得注意的是，表单本身并不执行身份验证，它仅仅是一种获得用户凭据的方法。身份验证是通过使用自定义代码访问用户名和密码数据库来实现的。 <br />验证用户身份后，服务器一般会通过某种方式向客户端表明其已经通过身份验证，可以进行后续请求。如果需要，您可以强制用户验证每个请求，但这样会影响性能和可伸缩性。您应考虑两种基本方法来识别以前登录过的客户端： <br />Cookie。Cookie 是最初由服务器向客户端发送的一小段数据。随后，由客户端随每个 HTTP 请求将其发送回服务器。它可以用作客户端已经通过身份验证的标志。ASP .NET 通过 CookieAuthenticationProvider 模块为您提供了使用 Cookie 进行表单身份验证的机制。大多数 Web 浏览器（包括 Internet Explorer 和 Netscape Navigator）均支持 Cookie。 <br />自定义。您可以实现自己的自定义机制来向服务器标识客户端。如果您的客户端禁用了 Cookie，您可以考虑在每个 URL 查询字符串中存储一个唯一标识符。或者使用存储在永久性顶级或不可见框架中的隐藏表单域。无论如何，您要确保黑客不能通过编程模拟成已经通过应用程序身份验证的用户。 <br />Cookie 广泛应用于使用表单身份验证的网站。.NET 的最初版本将仅支持使用 Cookie 的表单身份验证。 <br />典型应用方案<br />以下情况下，您应考虑使用表单验证： <br />用户名和密码存储在 Windows 帐户以外的位置。请注意，Windows 帐户也可以使用表单身份验证。 <br />您要在 Internet 上部署应用程序。 <br />您需要支持所有浏览器和客户端操作系统。 <br />您希望为用户提供自己的用户界面表单作为登录页。 <br />以下情况下，您不应考虑使用表单验证： <br />您要为公司 Intranet 部署应用程序，并且可以利用集成 Windows 身份验证。 <br />您不能通过编程访问来验证用户名和密码。<br />其他考虑<br />选择表单身份验证时，您还应考虑以下问题。 <br />保护表单身份验证<br />如果用户是通过登录页来提交密码的，您可以使用 SSL 来保护通道，以防密码被盗。如果您使用 Cookie 来维护用户在各个请求之间的标识，您应当了解黑客通过网络监视程序“盗用”用户 Cookie 的潜在危险。使用 Cookie 时，要使站点真正安全，唯一的方法是站点内的所有通讯都使用 SSL。对大多数商业网站来说，由于这种方法的运行开销太大，所以不切实际。使用 ASP .NET，您可以使服务器定期重生成 Cookie。这种使 Cookie 过期的策略是为了防止其他用户盗用 Cookie 访问站点。 <br />性能和可伸缩性<br />设计大流量网站时，您需要考虑验证用户身份所带来的性能影响。如果您预计会有大量用户同时登录，您需要尽快完成凭据确认过程。 <br />如果使用 SSL，由于必须执行额外的加密步骤，性能会明显下降。在 Web 中，您应将实现安全登录的服务器和内容服务器分开，以满足性能要求。 <br />检查 Cookie 的存在<br />如果您使用的是 .NET，则检查 Cookie 存在的进程是自动实现的。但如果不使用 .NET，则有两种基本方法： <br />实现 ISAPI 筛选器，它确认客户端请求中 Cookie 的存在，证明客户端已经通过身份验证。如果 Cookie 存在，则允许请求继续。如果 Cookie 不存在，则将客户端重定向到登录页。如上所述的 ISAPI 筛选器可以由 Microsoft Commerce Server 2000 实现。 <br />您可以在每个 Web 页的开始处编写代码检查 Cookie 是否存在，或编写由 Web 页传递的其他自定义值。如果标记不存在，代码可将用户重定向到登录页。这一实现方法很简单；但是，您可能无法保护除 ASP 页以外的资源。例如，图像文件可能仍然可以访问。 <br />如果您使用的是 ASP .NET，则可以利用表单身份验证提供的内置功能。 <br />使用表单身份验证与 Windows 帐户<br />如果您部署的是 Internet 应用程序，而您的用户在服务器中具有 Windows 帐户，则可以使用表单身份验证或 SSL 上的表单身份验证，以替代基本身份验证和简要身份验证。 <br />如果您的应用程序基于 Intranet，并且已经在使用集成 Windows 身份验证，则表单身份验证可能并非好的解决方案。您公司的安全策略可能也不允许用户将密码输入 HTML 表单。 <br />实现<br />要实现表单身份验证，您必须创建自己的登录页并重定向未验证客户端的 URL。您还必须创建自己的帐户查找方案。使用 ASP .NET，可以使用以下 Web.config 配置： <br />// web.config 文件<br />&lt;system.web&gt;<br />   &lt;authentication mode="Forms" /&gt;<br />&lt;/system.web&gt;</p>
<p>因为您实现的是自己的身份验证，一般可以将 IIS 配置为匿名身份验证。 <br />有关实现 SSL 的详细信息，请参阅以下文章。 <br />Web 安全性揭密：最大限度地利用 IIS 安全性（英文） <br />《Internet Information Services 5.0 资源指南》中的“配置 IIS 5.0 安全性”<br />Cookie<br />Cookie 是由 Web 服务器放在您的硬盘驱动器上的一个小文本文件。其主要目的是让服务器能够识别返回的客户端。无论是否存在身份验证机制，您都可以使用 Cookie。请考虑以下应用方案： <br />与表单身份验证结合使用。服务器根据身份验证向客户端发布一个 Cookie，并根据提交回服务器的 Cookie 来验证后续请求。 <br />仅用于向用户提供自定义内容的个性化站点。<br />ASP .NET 提供了一种机制来创建 Cookie 并自动检查客户端请求中是否存在 Cookie。可以使用 .NET 框架支持的三级 DES 方案对由 ASP .NET 创建的 Cookie 进行有选择的加密。您也可以实现自己的 Cookie 提供程序并在表单身份验证中使用。 <br />有关 Cookie 的详细信息，请参阅关于 Cookie 的信息（英文）。 <br />其他考虑<br />不同浏览器类型可能对 Cookie 的大小有不同的限制。RFC 2019 指定的大小限制为 4 KB。Internet Explorer 5 对 Cookie 没有大小限制。浏览器的安全设置必须配置为接受 Cookie，程序才能正常工作。</p>
<p>--------------------------------------------------------------------------------</p>
<p>Web 服务安全性<br />Web 服务是基于 ASP .NET 结构的应用程序，可以通过 Internet 编程调用。从安全角度看，它存在的问题与开发交互式网站的问题类似。您需要使用与保护 ASP .NET 资源相同的机制来保护 Web 服务（如 IIS 和 ASP .NET 身份验证提供程序）。但是，设计过程中您还需要考虑这些额外因素： <br />客户端交互。您的 Web 服务可能没有连接和输入安全凭据的交互用户。而您的“用户”可能是应用程序。 <br />方法级别安全性。您可能需要在方法级别授权用户，以限制使用特定方法，您可以采用类似于 COM+ 组件方法级别安全性的方法来实现这一目的。 <br />代理。您的 Web 服务可能需要（也可能不需要）呼叫其他服务并维护原始呼叫方的安全环境。 <br />Web 服务身份验证<br />Web 服务需要以某种方式接受用户凭据。如果服务是非交互式的，则需要获得呼叫方的安全标记，或需要显露适当的方法以允许提供凭据。以下身份验证方法容易使用，不需要用户输入凭据，对于可编程 Web 服务来说是很好的选择： <br />基本、简要和集成 Windows 身份验证 <br />证书映射身份验证 <br />应用程序专用或自定义身份验证 <br />以下的选项也有应用潜力： <br />Internet 协议安全性 <br />Passport <br />使用 Windows 帐户和 IIS 身份验证<br />您需要考虑的问题与本文身份验证方法一节中所述的问题一样。本实现方法所需的自定义代码最少，同时，您可以使用 Windows ACL 授权对其他资源的访问。 <br />使用证书和证书映射<br />当使用证书身份验证时，客户端和服务器之间可以进行无缝交互；即，客户端不必通过编程提供用户名和密码。而且，这是一种高度安全的机制。B2B 交易（如提交订单）是使用证书的理想场合。如果您使用证书映射来获取 Windows 用户帐户，您也可以使用 Windows ACL 来授权对资源的访问。 <br />自定义身份验证<br />您可以实现自定义身份验证解决方案。与集成 Windows 身份验证方法相比，此解决方案的优点是，不再需要应用程序来为每个用户维护各自的帐户。您还可以一起忽略 IIS 身份验证，而在 Web 服务代码中使用自己的自定义方法，并根据应用程序特定的要求进行优化。 <br />可能的 Web 服务自定义身份验证解决方案包括： <br />接受用户名和密码作为方法调用的参数。 <br />提供一种必须在调用其他方法之前调用的登录方法。您可以使用 Microsoft .NET 框架的 Cookie 功能来验证对登录方法的调用。 <br />使用 SOAP 标头或 SOAP 正文来存储凭据。 <br />创建自定义 HTTP 标头或正文来存储凭据。<br />Internet 协议安全性<br />如果您知道客户端的 IP 地址，例如，客户端是调用封装在 Web 服务业务逻辑的中间层 Web 服务器，则可以选择 Internet 协议安全性 (IPSec)。此方法允许您根据 IP 地址来限制连接到 Web 服务的计算机。 <br />该方法在 Internet 方案中不可行，因为您预先不知道客户端的 IP 地址。 <br />有关 IPSec 的详细信息，请参阅 MSDN 文章 Microsoft Windows 2000 服务器的 IP 安全性（英文）。 <br />在 Web 服务中使用 Passport<br />有时 Web 服务可能会使用 Passport 进行身份验证。但是，它的使用很有限，因为它要求将未通过验证的客户重定向到 Passport 站点。对非交互式客户端来说，重定向会出现问题，除非专门为此编程来处理重定向到 Passport 服务器的情况。 <br />授权<br />完成用户身份验证后，您可能需要授权其访问 Web 服务。以下是几种授权选项： <br />使用 Windows ACL <br />使用 URL 授权 <br />使用 .NET Principal 对象<br />使用 Windows ACL<br />使用 Windows ACL，您可以创建特定应用程序文件的文件系统许可。如果您的 Web 服务对用户进行 Windows 帐户身份验证并使用模拟，则可以使用此解决方案。 <br />使用 URL 授权<br />URLAuthorizationModule 将用户和角色映射到 URI 名称空间中的元素。该模块同时实现肯定和否定的授权声明。也就是说，该模块可以根据用户的某种身份（例如角色关系），选择性地允许或拒绝该用户访问 URI 名称空间中的任意元素。下面的例子为某些域用户授权，但拒绝其他用户。 <br />&lt;configuration&gt;<br />   &lt;system.web&gt;<br />         &lt;authentication mode="Windows" /&gt;<br />          &lt;authorization&gt;<br />              &lt;allow users="domain1\user, domain2\user2, domain1\user3 /&gt;<br />              &lt;deny users="*" /&gt;<br />          &lt;/authorization&gt;<br />    &lt;/system.web&gt;<br />&lt;/configuration&gt;<br />Windows Principal 对象<br />.NET 框架类库 (BCL) 中的 System.Security.Principal 名称空间提供了一个 WindowsPrincipal 对象来表示代码运行的安全环境。使用 IIS 中的 Windows 身份验证时，该对象将自动创建。它允许您检查 Windows 用户的 Windows 组成员，并相应地限制访问权限。 <br />Generic Principal 对象<br />Generic Principal 对象可根据您自己的自定义角色来创建。如果您拥有自己的用户/角色数据库，则可以使用它。Principal 对象在 OnAuthenticate 事件中填充。您可以将自定义表映射到在此事件中映射的 Windows 帐户。无论如何，您都可以为该特殊用户创建一个自定义 Principal 对象。 <br />对于已经通过身份验证的返回用户，您可以使用 Cookie 来重新为返回用户重新创建 Principal 对象。 <br />角色和方法级别安全性<br />您可能需要使用方法级别安全性来限制由特殊客户端当事者调用的特殊方法。有许多方法可以处理该问题。 <br />如果您使用 Windows 帐户，可以以 Windows 组的形式为用户创建角色。因为 ASP 线程将模拟客户端，您将获得一个 Windows Principal 对象；请使用以下方法： <br />为 ASP .NET 线程访问的受保护资源创建 ACL。 <br />从每一种方法调用 WindowsPrincipal 对象中的 IsInRole 方法，以验证调用方具有适当的权限。您还可以在代码中实现逻辑语句，根据客户端的组成员身份调用特定的子例程。 <br />如果您使用自定义数据库中的用户和角色创建 Generic Principal 对象： <br />您可以通过编程调用 Principal 对象的 IsInRole 方法以检查角色成员身份，其方式与上文所述的 Windows Principal 对象相同。 <br />如果您不使用 Principal 对象，则可以选择其他选项： <br />接受用户凭据作为方法调用的参数并进行查找。 <br />方法调用的第一项操作是验证 Cookie 的存在。 <br />创建一个登录方法返回自定义键值。后续的方法将接受此键值作为参数。这与使用受浏览器支持的 Cookie 类似，但是它在客户端不支持 Cookie 的情况下也可以使用。 <br />代理<br />和 ASP .NET 网站一样，Web 服务也存在同样的代理问题。要将安全环境代理到 Web 服务，您需要使用 Kerberos 身份验证，或者必须传递凭据以便于运行在其他计算机上的 Web 服务能够调用 LogonUser（对于 Windows 服务器）或等价身份验证 API（对于非 Windows 服务器）。 <br />客户端访问<br />如果您通过编程与 Web 服务连接，您可以利用 .NET 类进行客户端连接。.NET 客户端支持的身份验证协议有： <br />基本 <br />简要 <br />Windows 集成（NTLM 和 Kerberos） <br />证书 <br />自定义</p>
<p>--------------------------------------------------------------------------------</p>
<p>代码访问安全性<br />为了保护计算机系统不受恶意代码的干扰，也为了保证移动代码的安全运行，.NET 框架提供了一种称为代码访问安全性 (CAS) 的安全机制。CAS 是一种 .NET 安全特征，适用于所有 .NET 托管代码，如 ASP .NET Web 应用程序。尽管如此，在编写以下特定代码时您需要牢记这一点： <br />设计浏览器承载的控件 <br />承载第三方应用程序 <br />在共享服务器上承载来自不同供应商的程序集 <br />您希望保护某些本机功能（如文件写 API）以供某些程序集使用 <br />根据代码的来源和代码标识的其他特征（如强加密程序集名），CAS 允许代码有不同的可信度，这取决于您的安全策略。CAS 减少了您的代码被其他恶意代码滥用的可能性。它使您可以专门设置允许代码执行的操作，以及决不允许代码执行的操作。特别是，CAS 支持许可支持机制，通过该机制，代码可明确请求特定许可、或明确拒绝其他不需要的许可。 <br />代码访问许可<br />代码访问安全性依赖于代码访问许可概念。每个许可代表代码访问受保护资源（如文件、目录、注册表项）的权限或执行受保护操作（如调用非托管代码）的权限。代码将请求许可，而运行时安全策略将决定授予何种许可。有关完整列表，请参阅代码访问许可（英文）。 <br />.NET 允许管理员向应用程序分配预定义的许可集。这些许可集根据应用程序的可信度而有所不同。默认情况下，应用程序根据代码的数字签名、原始格式和应用程序位置等证据获得信任级别。 <br />例如，运行在 UNC 共享（在 Intranet 安全区域运行）上的应用程序将获得 LocalIntranet 许可集。而运行在本地计算机（在 MyComputer 安全区域运行）上的应用程序将获得 FullTrust 许可集。 <br />通过为 ASP .NET Web 应用程序分配信任级别，可以进一步配置它们。信任级别的配置是通过使用配置文件中的 &lt;trust&gt; 元素来实现的。 <br />&lt;trust level="Full | High | Low | None" originUrl="url" /&gt;<br />每个级别都决定了应用程序的许可程度，其细节在 XML 安全策略文件中指定。每一级别都映射到一个特定文件。ASP .NET 的默认映射是： <br />高 - 映射到 web_hightrust.config 这一级别提供的授权允许应用程序读/写应用程序目录（服从于操作系统许可），并允许应用程序取代身份验证 Principal 对象。它还限制应用程序调用非托管代码。 <br />低 - 映射到 web_lowtrust.config 这一级别允许应用程序读取应用程序目录，并提供有限的网络连接。如果 &lt;trust&gt; 元素的 originUrl 属性配置恰当，应用程序就能够连回其承载站点。 <br />无 - 映射到 web_notrust.config 这一级别提供基本执行许可，并支持应用程序使用独立存储（一种允许代码与保存数据安全关联的机制）。 <br />请注意，完全信任没有相应的配置文件，因为完全信任允许应用程序使用所有资源（服从于操作系统许可），如同在没有代码访问安全性的情况下运行一样（但 CAS 不能关闭托管代码）。您可以使用配置文件中的 &lt;securityPolicy&gt; 元素替代这些映射，也可以自定义和扩展每一级别。您还可创建自己的定义任意许可集的级别。以下所示为默认 &lt;securityPolicy&gt; 映射集。 <br />&lt;securityPolicy&gt;<br />   &lt;trustLevel name="Full" policyFile="internal" /&gt;<br />   &lt;trustLevel name="High" policyFile="web_hightrust.config" /&gt;<br />   &lt;trustLevel name="Low"  policyFile="web_lowtrust.config" /&gt;<br />   &lt;trustLevel name="None" policyFile="web_notrust.config" /&gt;<br />&lt;/securityPolicy&gt;<br />锁定配置设置<br />ASP .NET 配置在本质上是层次化的，在计算机级别、应用程序级别和子应用程序级别具有可选的配置文件。子级别配置文件可用于替代更高级别的设置，或用于添加其他配置信息。尽管它提供了很高的灵活性，但有时候管理员希望加强配置设置，不允许他们被指定的应用程序替代。例如，宿主网站的管理员希望指定代码访问安全级别，不允许单个应用程序更改它。结合使用 &lt;location&gt; 元素和 allowOverride 属性可以实现这一目的。 <br />例如，宿主网站的管理员希望确保所有应用程序都不能调用非托管代码。以下配置文件片段说明管理员如何锁定整个站点的代码访问配置设置，并限制高信任级别的应用程序（不允许调用非托管代码）： <br />&lt;location path="somesitepath" allowOverride="false"&gt;<br />  &lt;trust level="high" originUrl="http://somesite.com"; /&gt;<br />&lt;/location&gt;<br />path 属性可以指向站点或虚拟目录，它适用于指定目录及其所有子目录。在上面的示例中，如果将 allowOverride 设置为“假”，则能够保护站点内的所有应用程序不被 &lt;location&gt; 元素中指定的配置设置替代。请注意，锁定配置设置的功能适用于所有设置，而不仅限于信任级别这样的安全设置。 <br />有关详细信息，请参阅： <br />.NET 中的安全性：使用公共语言运行时限制代码访问权限（英文） <br />代码访问安全性（英文）</p>
<p>--------------------------------------------------------------------------------</p>
<p>通道安全性<br />通道通过远程处理边界（如 AppDomains、进程和计算机）来传输信息。.NET 框架提供两种远程处理通道：HTTP 和 TCP。 <br />如果您希望保护通过这些协议传输的机密或敏感信息，则需要考虑使用安全通道。除非信息没有加密保护，否则使用网络监视软件很容易中途截获和读取这些信息。 <br />以下是通道安全性的一些关键问题： <br />承载于 IIS 和 ASP .NET 中的 HTTP 通道支持使用 SSL 传送和接收安全数据。SSL 是设置安全通讯通道的最常用机制，可以在 IIS 内配置。<br />如果您希望使用非安全通道（如 HTTP/端口 80 或 TCP），则仍然可以使用加密 API 手动加密数据。 <br />可以在传输层下实现通道安全机制。如果您使用 Windows 2000，则可以利用 Internet 协议安全性 (IPSec)，在对应用程序透明的同时，达到保护数据传输的目的。 <br />如果您使用 ASP .NET 和 COM 或 DCOM 组件，并使用 DCOM 作为您的远程处理机制，则可以考虑使用 DCOM 数据包保密身份验证级别来加密 DCOM 通讯。 <br />有关详细信息，请参阅： <br />《Microsoft Windows 2000 Server 资源包》中的“保护 Web 通讯”，Microsoft Press <br />.NET 框架开发人员规范（英文）中的远程处理规范 <br />Microsoft Windows 2000 Server IP 安全性（英文） <br />MSDN 中的“设置 DCOM 和 NT 安全性”</p>
<p>--------------------------------------------------------------------------------</p>
<p>其他信息<br />要了解本文讨论的安全问题的其他信息，请参阅以下参考内容。 <br />《Microsoft Windows 2000 Server 资源包》中的“理解数字证书”，Microsoft Press <br />.NET 框架 SDK（英文） <br />Microsoft 知识库文章 Q158229，信息：IIS 应用程序的安全性部分（英文） <br />使用 Microsoft Windows 平台创建网站的蓝图（英文） <br />有关 Web 服务安全性的详细信息，请参阅以下参考材料。 <br />使用 SOAP 工具包保护 Web 服务（英文） <br />《设计基于 Web 的 Microsoft Windows 2000 安全应用程序》，Microsoft Press <br />Internet Information Services 5 安全性检查表（英文） <br />Microsoft 知识库文章 Q187506，运行 IIS 站点所需的 NTFS 权限列表（英文） <br />有关安全性的一般信息，请参阅： <br />Microsoft 安全性（英文）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 08:33:05</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%94%a8%e6%88%b7/" title="用户">用户</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e5%ba%94%e7%94%a8%e7%a8%8b%e5%ba%8f/" title="应用程序">应用程序</a>, <a href="https://www.iamivan.net/tag/windows/" title="windows">windows</a>, <a href="https://www.iamivan.net/tag/%e9%aa%8c%e8%af%81/" title="验证">验证</a>, <a href="https://www.iamivan.net/tag/%e8%ba%ab%e4%bb%bd/" title="身份">身份</a>, <a href="https://www.iamivan.net/tag/%e8%ba%ab%e4%bb%bd%e9%aa%8c%e8%af%81/" title="身份验证">身份验证</a>, <a href="https://www.iamivan.net/tag/kerberos-v5/" title="kerberos v5">kerberos v5</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e6%8b%9f%e7%99%bb%e5%bd%95/" title="模拟登录">模拟登录</a>, <a href="https://www.iamivan.net/tag/windows%e8%ba%ab%e4%bb%bd%e9%aa%8c%e8%af%81/" title="windows身份验证">windows身份验证</a>, <a href="https://www.iamivan.net/tag/java-%e6%a8%a1%e6%8b%9f%e7%99%bb%e5%bd%95-cookie/" title="java 模拟登录 cookie">java 模拟登录 cookie</a>, <a href="https://www.iamivan.net/tag/windows-netjava%e8%ba%ab%e4%bb%bd%e9%aa%8c%e8%af%81/" title="windows&period;netjava身份验证">windows&period;netjava身份验证</a>, <a href="https://www.iamivan.net/tag/%e6%89%8b%e6%9c%ba%e6%b5%8f%e8%a7%88%e5%99%a8%e5%af%86%e7%a0%81asp-net/" title="手机浏览器密码asp&period;net">手机浏览器密码asp&period;net</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e6%8b%9f%e5%b8%90%e6%88%b7/" title="模拟帐户">模拟帐户</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ASP .NET 中的身份验证：.NET 安全性指导的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/yMAdRnb.html" rel="bookmark">asp&period;net中的身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net asp.net中的身份验证 我用的是基于窗体的验证,这也是最常用的,我只写一下摘要,源代码太长,但应该不影响理解代码. web.config的修改:&lt;authentication mode=&quot;Forms&quot; /&gt; 用户的登陆验证方法,:这里有两个输入控件的,一个是user_tb,用来输入用户,一个是psw_tb,用来输入密码private void Button1_Click(object sender, System.EventArgs e){//用户登陆验			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL712kM.html" rel="bookmark">也谈ASP&period;NET 中的身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.配置安全身份验证模式 在Web.config 文件中,通过 &lt;authentication&gt; 节可以配置 ASP.NET 使用的安全身份验证模式,以标识传入的用户. &lt;authentication mode=&quot;[Windows|Forms|Passport|None]&quot;&gt;&lt;forms&gt;...&lt;/forms&gt;&lt;passport/&gt;&lt;/authentication&gt; &lt;authentication&gt; 节			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEEla3b.html" rel="bookmark">一起谈&period;NET技术，也谈ASP&period;NET 中的身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.配置安全身份验证模式 在Web.config 文件中,通过 &lt;authentication&gt; 节可以配置 ASP.NET 使用的安全身份验证模式,以标识传入的用户. &lt;authentication mode=&quot;[Windows|Forms|Passport|None]&quot;&gt; &lt;forms&gt;...&lt;/forms&gt; &lt;passport/&gt; &lt;/authentication&gt; &lt;authentication&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mg0Kvmp.html" rel="bookmark">也谈&OpenCurlyDoubleQuote;&period;NET研究&rdquo;ASP&period;NET 中的身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.配置安全身份验证模式 在Web.config 文件中,通过 &lt;authentication&gt; 节可以配置 ASP.NET 使用的安全身份验证模式,以标识传入的用户. &lt;authentication mode=&quot;[Windows|Forms|Passport|None]&quot;&gt; &lt;forms&gt;...&lt;/forms&gt; &lt;passport/&gt; &lt;/authentication&gt; &lt;authentication&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvK6qap.html" rel="bookmark">利用&period;net的内部机制在asp&period;net中实现身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在.net内部存在一些默认机制,具体说来有如下: (1)如果类的实例字段没有赋初始值,那么它们就会被赋默认值,对于引用类 型字段的默认值为null,对于简单值类型字段(即数值类型)默认值为对应形式 的0(如sbyte.byte.short.ushort.int.uint.long 和 ulong都是0,而char 类型字段的默认值值是'\0x0000',float类型字段是0.0f,double类型字段是 0.0d等等). (2)如果类中赋初值的静态字段,那么自动生成一个静态构造函数,在静态函			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY54BeM.html" rel="bookmark">windows身份验证-ASP&period;NET 使用Windows身份验证 怎么获取登陆用户的密码？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 ASP.NET 使用Windows身份验证 怎么获取登陆用户的密码? 我现在想在web程序中发送邮件(或类似需要域验证的功能),其中Credentials我想使用当前登陆用户的. 请问在这个时候怎么获取密码或有什么别的方式处理? 解决方案 无法获取的,如果可以获取的话,你的电脑系统就没有任何安全性可言... 解决方案二: 只知道里面有个SAM文件 解决方案三: 你指的是,我发布个ASP.NET应用程序,你访问了,我就可以获取到你的windows登录用户和密码? 你觉得这可能么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zG43ob.html" rel="bookmark">Asp&period;net中基于Forms验证的角色验证授权</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net Asp.net中基于Forms验证的角色验证授权 Asp.net的身份验证有有三种,分别是&quot;Windows | Forms | Passport&quot;,其中又以Forms验证用的最多,也最灵活.Forms 验证方式对基于用户的验证授权提供了很好的支持,可以通过一个登录页面验证用户的身份,将此用户的身份发回到客户端的Cookie,之后此用户再访问这个web应用就会连同这个身份Cookie一起发送到服务端.服务端上的授权设置就可以根据不同目录对不同用户的访问授权进行控制了. 问			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPlkXAp.html" rel="bookmark">详解ASP&period;NET Core和ASP&period;NET Framework共享身份验证&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				.NET Core 已经热了好一阵子,1.1版本发布后其可用性也越来越高,开源.组件化.跨平台.性能优秀.社区活跃等等标签再加上&quot;微软爸爸&quot;主推和大力支持,尽管现阶段对比.net framework还是比较&quot;稚嫩&quot;,但可以想象到它光明的前景.作为.net 开发者你是否已经开始尝试将项目迁移到.net core上?这其中要解决的一个较大的问题就是如何让你的.net core和老.net framework站点实现身份验证兼容! 1.第一篇章 我们先来看看.net co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGZjDOp.html" rel="bookmark">ASP&period;NET中 RegularExpressValidator&lpar;正则验证&rpar;的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ASP.NET中 RegularExpressValidator(正则验证)的使用 ylbtech-ASP.NET-Control-Validator: RegularExpressValidator(正则验证)的使用  ASP.NET中 RegularExpressValidator(正则验证)的使用. 1.A,运行效果返回顶部 RegularExpressionValidator:正则验证 属性: ControlToValidate:要验证的控件 ErrorMessage:错误提示信息			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGE6MK.html" rel="bookmark" class="title">360极速浏览器如何清除浏览数据</a>
					<div>
						您可以全面控制从浏览器中删除的浏览数据类型以及要删除的时间范围. 打开清除浏览数据对话框的方法: 点击状态栏上的&quot;清除浏览数据&quot; 在&quot;选项&quot; – &quot;高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJlVqM.html" rel="bookmark" class="title">参考&colon;整理HTML&comma;CSS和Javascript在线手册</a>
					<div>
						整理了一批比较好用的前端开发相关的速查手册,希望对大家有用,也希望大家能够提交一些自己认为比较好的速查手册. 本文将保持更新,在我们或者读者发现有新的手册的时候,我们会立即更新本文的. HTML速查手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgax3z.html" rel="bookmark" class="title">百度常用的搜索指令分享</a>
					<div>
						用户在搜索引擎中搜索普通词语外,还可以使用一些特殊的指令,对于SEO人员来说,这样可以使你更好的分析竞争对手和查找更多的资源. 一 双引号的使用 把搜索的词语放在双引号(&quot;&quot;)内, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGXQ3b.html" rel="bookmark" class="title">全面了解网络测试工具</a>
					<div>
						测试工具是实现自动化测试的手段,合理使用测试工具可以不仅可以提高网络诊断能力,也给网络管理带来方便.一般说来,广义上的网络测试工具可以分为物理线缆测试仪.网络运行模拟工具.协议分析仪.专用网络测试设备 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo63mVz.html" rel="bookmark" class="title">使用Rational Method Composer和Jazz实现开发过程的文档化和自动化（二）</a>
					<div>
						采用现有流程 简介 在本系列文章的第 1 部分中,Bruce MacIsaac 解释了软件开发方法的价值.本文将介绍如何采用在 IBM Rational Method Composer 中定义的流程, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLrlZb.html" rel="bookmark" class="title">利用delphi完全控制桌面的实现</a>
					<div>
						在windows 中系统桌面和开始菜单可以说是它的一大特色,其实我们可以利用delphi轻易地在应用程序中实现这种技术 : 新建一个应用程序, 将form1窗体的borderstyle属性设置为bsn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr7yvp.html" rel="bookmark" class="title">将字体嵌入PowerPoint文件随身携带</a>
					<div>
						我们经常会遇到这样的情况:由于每台计算机中安装的字体文件不同,在一台计算机上制作好的PowerPoint课件在另一台计算机上打开时,设定的字体会发生改变,影响课件的播放效果. 其实,只要在保存Powe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Peg8M.html" rel="bookmark" class="title">Xp系统提示磁盘空间不足怎么办</a>
					<div>
						   Xp系统提示磁盘空间不足怎么办 1.点击开始按钮,点击&quot;运行&quot;; 2.在运行框中输入&quot;regedit&quot;按下回车键打开&quot;注册表编辑器&quot;; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLag48z.html" rel="bookmark" class="title">硬盘硬故障的维修方法</a>
					<div>
						对于硬盘的硬故障,进行维修是比较复杂的,特别是对于非电路部分,对一般用户而言是不可维修的.因此,当出现硬故障时,我们建议用户把故障部件送到 维修中心进行维修,或者干脆购买新的硬盘驱动器或者新的硬盘控制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxW5gRb.html" rel="bookmark" class="title">Win8恢复&OpenCurlyDoubleQuote;确认文件夹替换&rdquo;窗口的方法</a>
					<div>
						  1.先在Win8资源管理器面板上,点击&quot;文件夹选项&quot;,然后在打开的文件夹选项窗口上,切换至&quot;查看&quot;栏; 2.在Win8系统查看栏中,取消勾选&quot;隐藏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7Wk6b.html" rel="bookmark" class="title">maven项目管理</a>
					<div>
						systemPath方式 有些不通用的包,maven仓库没有,只能通过本地包依赖,就像下面方式: 在需要依赖的项目建lib文件夹,如下: 然后在pom.xml项目管理文件里面加入本地依赖,如下     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6m7jz.html" rel="bookmark" class="title">应用程序与驱动程序共享内存问题</a>
					<div>
						问题描述 应用程序与驱动程序共享内存问题 在应用程序中构建一块内存:在驱动程序的DeviceIoControl处理函数中,通过(PUCHAR)MmGetSystemAddressForMdl(Irp- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3aV4z.html" rel="bookmark" class="title">imageview-ios中的uiscrollview如何获取子试图？</a>
					<div>
						问题描述 ios中的uiscrollview如何获取子试图? uiscrollview中有很多imageview,当点击其中的imageview时更改点击的imageview的图片如何操作? 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVarAb.html" rel="bookmark" class="title">java请问这个super是什么意思？</a>
					<div>
						问题描述 java请问这个super是什么意思? public class S { int a ; int b; public SxtArrayList(int a, int b) { super() ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6831z.html" rel="bookmark" class="title">迅雷2013迅数榜发布 全国下载速度重排座次</a>
					<div>
						3月25日,中国互联网下载及云计算服务领域巨头迅雷对外发布2013年第一期迅数榜.报告首次以第三方视角,从用户体验角度揭晓了当前各省市各大运营商.不同区域公共WIFI的真实下载速度. 权威发布:第三方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Z3xgM.html" rel="bookmark" class="title">android-主动请求蓝牙配对（Android）</a>
					<div>
						问题描述 主动请求蓝牙配对(Android) 我现在已经得到了附近蓝牙设备BluetoothDevice,怎么主动发送配对请求,在网上找了许多答案,但是好像都是一些聊天方面的内容要用到Bluetoot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba76m2p.html" rel="bookmark" class="title">Cocos2d-x跨Android&amp;amp&semi;amp&semi;iOS平台开发入门</a>
					<div>
						很好的一篇译文,在此感谢原作者和译者.由于此文写的很早,所以文中提到的一些工具已经升级了,有了一些新的界面和操作,但大体还是能和新版本联系起来的. 原文地址:http://www.cocoachina ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZowZp.html" rel="bookmark" class="title">电子商务介入房产交易</a>
					<div>
						[深圳商报讯](记者 李忠辉)日前,买房快线(www.4000666666.com)宣布正式上线运营,并在国内首创新的二手房网上交易模式. 据买房快线总裁宛进介绍,买房快线将与深圳320多家房产中介公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBaXDb.html" rel="bookmark" class="title">Linux下smartmontools工具安装使用方法</a>
					<div>
						环境: 系统环境:CenetOS6.4 x86_64 一.什么是S.M.A.R.T. smart是一种磁盘自我分析检测技术,早在90年代末就基本得到了普及,每一块硬盘(包括IDE.SCSI)在运行的时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye32JM.html" rel="bookmark" class="title">eclipse里面布置resin总是出错   求解答</a>
					<div>
						问题描述 eclipse里面布置resin总是出错 求解答 运行的时候会出现图一的错误,之后点击确定之后会出现图二的错误! 尝试了重装几次未果,网上搜索的配置方法尝试一下也不行!前来求助!大家帮我解答 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKd86p.html" rel="bookmark" class="title">Cocos2d-x学习笔记之Hello World源码分析&lowbar;C 语言</a>
					<div>
						首先我们来说一下游戏的原理,游戏类似于一场电影,早期的电影不就是靠一张张的图片放出来的吗?把场景人物什么的画在一幅幅图片上,然后从第一张图片开始播放就可以了.游戏更是如此,其实我们玩的游戏看到的画面都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBX15z.html" rel="bookmark" class="title">张楠：网站策划之如何提高用户参与度</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 网站策划.网站运营词典中有个叫&quot;用户参与度&quot;的词语,相信大家并不陌生,由于网站类型各不相同,比如: 1.交友网站,会利用交友活动的报 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7x7jdb.html" rel="bookmark" class="title">孙怡雪精彩女人的另类财富</a>
					<div>
						真正做餐饮以后我才知道什么是痛苦,等待,落寞,孤独,承受,这些都体验了一遍. 很难定义孙怡雪是个大女人或者小女人,大气爽快的是她,温柔似水的也是她.驰骋商海,屡获奇胜的是她,燕儿楠语,楚楚可人的还是她 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyNd6z.html" rel="bookmark" class="title">求救啊！！！vs2010启动时候错误，说检查activityLog&period;xml文件</a>
					<div>
						问题描述 大神们,求救啊!!!!!!!如图: 解决方案 解决方案二:你可以先卸载Refactor插件解决方案三:看看在安装一下Refactor解决方案四:去哪里安装refactor啊?解决方案五:以前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6qYqM.html" rel="bookmark" class="title">Hibernate&plus;Spring&plus;Struts扩展Struts&lowbar;JSP编程</a>
					<div>
						简介: 我看到很多项目中,开发者实现了自己的MVC框架,并不是因为他们想做同Struts根本不同的东西,而是因为他们并没有意识到如何扩展Struts.开发自己的MVC框架可以获得全部的控制权,但是这也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0NWNp.html" rel="bookmark" class="title">jquery使用animate方法实现控制元素移动&lowbar;jquery</a>
					<div>
						本文实例讲述了jquery使用animate方法实现控制元素移动.分享给大家供大家参考.具体分析如下: 通过jquery的animate方法控制元素移动,这里需要将元素的位置定义为relative,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1N0N9p.html" rel="bookmark" class="title">ios从服务器拿到历史记录导入demo的数据库显示问题</a>
					<div>
						问题描述 读取数据库历史记录时:如何让我发的消息显示在右边 解决方案 给message.from   和message.to  赋值解决方案二:你拉取的你们自己的服务器上的消息,那么你接收和发送是怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJeBWVp.html" rel="bookmark" class="title">最具话语权大数据分析厂商TOP50排行榜</a>
					<div>
						文章讲的是最具话语权大数据分析厂商TOP50排行榜,如今,几乎每个IT人士都在谈论&quot;大数据&quot;,它不仅是企业趋势,也是一个改变了人类生活的技术创新.大数据对行业用户的重要性也日益突出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5OOvmb.html" rel="bookmark" class="title">中移动山东推3G上网计时收费：最低每小时3毛</a>
					<div>
						6月3日上午消息,中国移动日前在山东推出最新3G上网资费套餐,除了按流量计费外,也有按时长计费套餐,最优惠的一档套餐,本地上网每小时仅需3毛. 此次中国移动山东公司推出的套餐分为包流量套餐和包时长套餐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDjj7vM.html" rel="bookmark" class="title">陈慧琳做法事超度两亡婴闭关一年停工停产</a>
					<div>
						陈慧琳做法事超度两亡婴(1 /8张) 陈慧琳上周五透过blog表示腹中五个月大的一对双胞胎女儿已经不幸流产.据知她三月初突然作动,经过医生两日两夜的抢救,胎儿始终不保.虽然两条小生命无缘来到人世,但医 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
